#ifndef lcd_h_
#define lcd_h_

#include <avr/io.h> // for AVR hardware

// port and pin definitions
#define LCD_PORT PORTF
#define LCD_DDR DDRF
#define LCD_PIN_E 5
#define LCD_PIN_RS 4
#define LCD_PIN_LED 6

// macros to control LCD's backlight
#define lcd_backlight(x) LCD_PORT = x ? (LCD_PORT | _BV(LCD_PIN_LED)) : (PORTF & ~_BV(LCD_PIN_LED)
#define lcd_backlight_on() LCD_PORT |= _BV(LCD_PIN_LED)
#define lcd_backlight_off() LCD_PORT &= ~_BV(LCD_PIN_LED)

// function prototypes

// initialize pin states
inline void lcd_init_pins();

// send a byte to the LCD, RS pin must be setup before calling this function
inline void lcd_sendbyte(uint8_t x);

// display a character on the LCD
void lcd_sendchar(char c);

// send a command to the LCD
void lcd_sendcmd(uint8_t data);

// sets the position of the cursor, x is 0 indexed, line is not
void lcd_setpos(uint8_t x, uint8_t line);

// initialize the LCD
void lcd_init();

#endif